summaryrefslogtreecommitdiff
path: root/oh-my-zsh/plugins/svn
diff options
context:
space:
mode:
Diffstat (limited to 'oh-my-zsh/plugins/svn')
-rw-r--r--oh-my-zsh/plugins/svn/README.md67
-rw-r--r--oh-my-zsh/plugins/svn/svn.plugin.zsh89
2 files changed, 156 insertions, 0 deletions
diff --git a/oh-my-zsh/plugins/svn/README.md b/oh-my-zsh/plugins/svn/README.md
new file mode 100644
index 0000000..cab166a
--- /dev/null
+++ b/oh-my-zsh/plugins/svn/README.md
@@ -0,0 +1,67 @@
+# `svn` plugin
+
+This plugin adds some utility functions to display additional information regarding your current
+svn repository. See https://subversion.apache.org/ for the full svn documentation.
+
+To use it, add `svn` to your plugins array:
+
+```zsh
+plugins=(... svn)
+```
+
+## Functions
+
+| Command | Description |
+|:----------------------|:--------------------------------------------|
+| `svn_prompt_info` | Shows svn prompt in themes |
+| `in_svn` | Checks if we're in an svn repository |
+| `svn_get_repo_name` | Get repository name |
+| `svn_get_branch_name` | Get branch name (see [caveats](#caveats)) |
+| `svn_get_rev_nr` | Get revision number |
+| `svn_dirty` | Checks if there are changes in the svn repo |
+
+## Caveats
+
+The plugin expects the first directory to be the current branch / tag / trunk. So it returns
+the first path element if you don't use branches.
+
+## Usage on themes
+
+To use this in the `agnoster` theme follow these instructions:
+
+1. Enable the svn plugin
+
+2. Add the following lines to your `zshrc` file:
+
+ ```shell
+ prompt_svn() {
+ local rev branch
+ if in_svn; then
+ rev=$(svn_get_rev_nr)
+ branch=$(svn_get_branch_name)
+ if [[ $(svn_dirty_choose_pwd 1 0) -eq 1 ]]; then
+ prompt_segment yellow black
+ echo -n "$rev@$branch"
+ echo -n "±"
+ else
+ prompt_segment green black
+ echo -n "$rev@$branch"
+ fi
+ fi
+ }
+ ```
+
+3. Override the agnoster `build_prompt()` function:
+
+ ```zsh
+ build_prompt() {
+ RETVAL=$?
+ prompt_status
+ prompt_context
+ prompt_dir
+ prompt_git
+ prompt_svn
+ prompt_end
+ }
+ ```
+
diff --git a/oh-my-zsh/plugins/svn/svn.plugin.zsh b/oh-my-zsh/plugins/svn/svn.plugin.zsh
new file mode 100644
index 0000000..22b07b4
--- /dev/null
+++ b/oh-my-zsh/plugins/svn/svn.plugin.zsh
@@ -0,0 +1,89 @@
+svn_prompt_info() {
+ local info display
+ info="$(LANG= svn info 2>/dev/null)" || return 1
+
+ if [[ "$SVN_SHOW_BRANCH" = true ]]; then
+ display="$(svn_get_branch_name "$info")"
+ else
+ display="$(svn_get_repo_name "$info")"
+ fi
+
+ printf '%s%s%s%s%s%s%s%s%s%s' \
+ "$ZSH_PROMPT_BASE_COLOR" \
+ "$ZSH_THEME_SVN_PROMPT_PREFIX" \
+ "$ZSH_THEME_REPO_NAME_COLOR" \
+ "${display:gs/%/%%}" \
+ "$ZSH_PROMPT_BASE_COLOR" \
+ "$ZSH_THEME_SVN_PROMPT_SUFFIX" \
+ "$ZSH_PROMPT_BASE_COLOR" \
+ "$(svn_dirty $info)" \
+ "$(svn_dirty_pwd)" \
+ "$ZSH_PROMPT_BASE_COLOR"
+}
+
+in_svn() {
+ svn info &>/dev/null
+}
+
+svn_get_repo_name() {
+ local info name
+ info="${1:-$(LANG= svn info 2>/dev/null)}"
+ name="$(sed -n 's/^Repository\ Root:\ .*\///p' <<< "$info")"
+ omz_urldecode "$name"
+}
+
+svn_get_branch_name() {
+ local info branch
+ info="${1:-$(LANG= svn info 2>/dev/null)}"
+ branch=$(
+ awk -F/ '/^URL:/ {
+ for (i=0; i<=NF; i++) {
+ if ($i == "branches" || $i == "tags" ) {
+ print $(i+1)
+ break
+ };
+ if ($i == "trunk") {
+ print $i
+ break
+ }
+ }
+ }' <<< "$info"
+ )
+ branch="$(omz_urldecode "$branch")"
+
+ echo "${branch:-$(svn_get_repo_name "$info")}"
+}
+
+svn_get_rev_nr() {
+ sed -n 's/Revision:\ //p' <<<"${1:-$(LANG= svn info 2>/dev/null)}"
+}
+
+svn_dirty() {
+ svn_dirty_choose "${1:-$(LANG= svn info 2>/dev/null)}" $ZSH_THEME_SVN_PROMPT_DIRTY $ZSH_THEME_SVN_PROMPT_CLEAN
+}
+
+svn_dirty_choose() {
+ local root
+ root=$(sed -n 's/^Working Copy Root Path: //p' <<< "${1:-$(LANG= svn info 2>/dev/null)}")
+ if LANG= svn status "$root" 2>/dev/null | command grep -Eq '^\s*[ACDIM!?L]'; then
+ # Grep exits with 0 when "One or more lines were selected", return "dirty".
+ echo $2
+ else
+ # Otherwise, no lines were found, or an error occurred. Return clean.
+ echo $3
+ fi
+}
+
+svn_dirty_pwd () {
+ svn_dirty_choose_pwd $ZSH_THEME_SVN_PROMPT_DIRTY_PWD $ZSH_THEME_SVN_PROMPT_CLEAN_PWD
+}
+
+svn_dirty_choose_pwd () {
+ if LANG= svn status "$PWD" 2>/dev/null | command grep -Eq '^\s*[ACDIM!?L]'; then
+ # Grep exits with 0 when "One or more lines were selected", return "dirty".
+ echo $1
+ else
+ # Otherwise, no lines were found, or an error occurred. Return clean.
+ echo $2
+ fi
+}